<template>
  <el-date-picker
    v-model="periods"
    @change="onChange"
    type="monthrange"
    format="MMM yyyy"
    start-placeholder="Дата начала"
    end-placeholder="Дата окончания"
  />
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "@/components/common/ComponentMixin";

@Component
export default class ComponentSelectMonthRange extends Mixins(ComponentMixin) {
  /** @property {string} eventName - название события, которое гененрирует компонент. */
  private readonly eventName = "on-selected-month-range";
  /** @property {Date[]} periods - коллекция дат периода. */
  private periods: Date[] = [];

  /**
   * Метод срабатывает после изменения периода.
   */
  private onChange(): void {
    // Оповещаем подписчиков об изменении выбранного периода
    this.notify(this.eventName, this.periods);
  }
}
</script>

<style lang="scss">
.el-date-editor--monthrange.el-input,
.el-date-editor--monthrange.el-input__inner {
  width: auto !important;
}
</style>
